#include <iostream>
#include <algorithm>

#include "MyClass.hpp"

using namespace std;

class MyClass::PImpl
{
public:
  PImpl(void)
  {
    cout << "MyClass::PImpl::PImpl()" << endl;
  }
  ~PImpl(void)
  {
    cout << "MyClass::PImpl::~PImpl()" << endl;
  }
  void doSth(void)
  {
    cout << "hello PImpl!" << endl;
  }
};


MyClass::MyClass(void):
  pimpl_( new PImpl )
{
  cout << "MyClass::MyClass()" << endl;
}

MyClass::~MyClass(void)
{
  cout << "MyClass::~MyClass()" << endl;
}

#ifdef MAKE_IT_WORK
MyClass::MyClass(MyClass&& other):
  pimpl_( std::move( other.pimpl_ ) )
{ }

MyClass& MyClass::operator=(MyClass&& other)
{
  MyClass tmp( std::move(other) );
  swap(pimpl_, tmp.pimpl_);
  return *this;
}
#endif

void MyClass::doSth(void)
{
  pimpl_->doSth();
}
